TooltipDetachHandler = class(Turbine.UI.Window)
function TooltipDetachHandler:Constructor()
    Turbine.UI.Window.Constructor(self)

    local x = Settings.TBX
    local y = Settings.TBY
    local width = 100
    local height = 5000
    self:SetVisible(true)
    self:SetPosition(x, y)
    self:SetSize(width, height)
    --self:SetBackColor(GetRandomColour())
    self:SetMouseVisible(false)

    self.TargetSelectionsBoxes = {}
    self.TargetSelections = {}
    self.VisibleBox = {}

    self.targettingAllowed = false

    self.ViewingWindow = {}

    self.BoxCount = 0

    self.Shuffle = false

    self.player = Turbine.Gameplay.LocalPlayer.GetInstance()

    self.callback = {}

    --self.moveBox = MoveBox(self, width, 50, "TargetBox")    

    --[[
    self.TargetChanged = function(sender)
        local PTarget = sender:GetTarget()
        if PTarget then
            local TargetName = PTarget:GetName()
            --E:SetBackColor(GetRandomColour())
    
            self.TargetSelections[PTarget:GetName()] = PTarget
            self.TargetSelectionsBoxes[TargetName] = UITooltipBox(500, 500, sender:GetTarget(), PTarget:GetName())
        end
    end

    self:SetWantsKeyEvents(true)
	self.KeyDown = function(sender, args)
		if (args.Action == Turbine.UI.Lotro.Action.Tooltip_Detach) then
			self.TargetChanged(Turbine.Gameplay.LocalPlayer.GetInstance())
		end
	end
    --]]
end

function TooltipDetachHandler:Unload()
end

UITooltipBox = class(Turbine.UI.Window)
function UITooltipBox:Constructor(x, y, entity, name)
    Turbine.UI.Window.Constructor(self)
    local width = 100
    local height = 50
    self:SetVisible(true)
    self:SetPosition(x, y)
    self:SetSize(width, height)
    --self:SetBackColor(GetRandomColour())
    self:SetMouseVisible(true)

    self.ViewingWindow = 15

    self.entityBox = entity

    self.E = entity
    --[[
    self.E = Turbine.UI.Lotro.EntityControl()
    self.E:SetParent(self)
    self.E:SetVisible(true)
    self.E:SetMouseVisible(true)
    self.E:SetSize(100, 50)
    self.E:SetBackColor(Turbine.UI.Color.Black)
    self.E:SetEntity(entity)
    --]]

    self.Moving = false

    self.E.MouseDown = function(sender,args)
        self.MoveX = args.X
        self.MoveY = args.Y
        self.Moving = true
    end

    self.E.MouseUp = function()
        self.Moving = false
    end

    self.E.MouseMove = function(sender,args)
        if self.Moving then
        local newLeft = self:GetLeft() - (self.MoveX - args.X)
        local newTop = self:GetTop() - (self.MoveY - args.Y)
        self:SetPosition(newLeft,newTop)
        end
    end



    self.opacityNameWindow = Turbine.UI.Window()
    self.opacityNameWindow:SetParent(self)
    self.opacityNameWindow:SetSize(20, 20)
    self.opacityNameWindow:SetPosition(width - 20, 0)
    self.opacityNameWindow:SetBackColor(Turbine.UI.Color(0, 0, 0))
    self.opacityNameWindow:SetOpacity(0.3)
    self.opacityNameWindow:SetVisible(true)
    self.opacityNameWindow:SetMouseVisible(false)
    self.opacityNameWindow:SetBackColor(Turbine.UI.Color(1, 0, 0))

    self.containerWindow = Turbine.UI.Window()
    self.containerWindow:SetParent(self)
    self.containerWindow:SetSize(width, height)
    --self.opacityNameWindow2:SetBackColor(Turbine.UI.Color(0, 0, 0))
    --self.opacityNameWindow2:SetOpacity(0.3)
    self.containerWindow:SetVisible(true)
    self.containerWindow:SetMouseVisible(false)

    self.NameLabel = Turbine.UI.Label()
    self.NameLabel:SetParent(self.containerWindow)
    self.NameLabel:SetSize(100, 15)
    self.NameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.NameLabel:SetMouseVisible(false)
    self.NameLabel:SetMarkupEnabled(true)
    self.NameLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
    self.NameLabel:SetText(name)

    self.IconLabel = Turbine.UI.Label()
    self.IconLabel:SetParent(self.containerWindow)
    self.IconLabel:SetPosition(34, 15)
    self.IconLabel:SetSize(32, 32)
    self.IconLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.IconLabel:SetMouseVisible(false)
    self.IconLabel:SetBackground(iconType)
end